<?php

/**
 * Fpaeventom
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     SetForms Team <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class Fpaeventom extends DaoFpaEventom
{
    protected static $historico_link = 'NREVENTOM'; /* Nao utilizado */
    protected static $historico_class = 'Fpaeventoh'; /* Nao utilizado */


    /**
     * Retorna o ultimo evento historico.
     *
     * @param string $vr_link Valor do link.
     *
     * @return Fpaeventoh
     */
    /* public static function retornaUltimoHistorico($vr_link){
        $vinculos_historico = Fpaeventoh::getObjectsByWhere(
            'NREVENTOM = ?', array($vr_link)
        );
        $vh = end($vinculos_historico);
        return $vh;
    }
     */


    /**
     * Retorna array de eventos com  historico agregado.
     *
     * @param integer $nrOrg       Numero da Organizacao.
     * @param integer $nrOrgPadrao Numero da Organizacao.
     *
     * @return array FpaeventomEntity
     *
     * @author alessandrobartels -
     *         alessandrobartels - 27/06/2011 - Implementacao do NRORG
     *         alessandrobartels - 11/07/2011 - Implementacao da Org Padrao.
     */
    public static function retornaEventos($nrOrg, $nrOrgPadrao){
         $eventos = array();
         try{
            $eventos = self::getObjectsByWhere(
                'NRORG = ?
                 OR NRORG = ?',
                array(
                 $nrOrg, $nrOrgPadrao,
                )
            );
        } catch (Exception $e){
            echo $e->getMessage().'<br />';
        }
        foreach ($eventos as &$evento) {
                $dao = $evento->getDao();
                $historico = Fpaeventoh::retornaUltimoHistorico($dao->NREVENTOM);
            // TRATAMENTO PRO HISTÓRICO - BORBA 27/03/2013
                if($historico !== null){
                    $evento->historico = $historico;
                }else{
                    throw new Exception('Não existe histórico para o evento '.$dao->NREVENTOM);
                }
        }

        return $eventos;
    }


    /**
     * Retorna lista de eventos que fazem  base para a media.
     *
     * @param integer $nrOrg Numero da Organizacao.
     *
     * @return array FpaeventomEntity
     *
     * @author alessandrobartels -
     *         alessandrobartels - 27/06/2011 - Implementacao do NRORG
     */

    public static function retornaListaEventosMedia($nrOrg, $nrOrgPadrao){
        $eventos_media = array();

        /* $db = TkDb::singleton(); */
        $db = \Setforms2\Runtime\Connection::getInstance();
        $sql = 'SELECT * FROM FPA_EVENTOM EM
				WHERE
				(NRORG = '.$nrOrg.'
				 OR NRORG = '.$nrOrgPadrao.')
				AND EM.NREVENTOM IN
  						(SELECT EH.NREVENTOM  FROM FPA_EVENTOH EH
    					WHERE EH.IDMEDIAEVENFERI = \'S\'
    					AND EH.DTMESCOMPETENC = (SELECT MAX(EH1.DTMESCOMPETENC)
    											FROM FPA_EVENTOH EH1
                              					WHERE EH1.NREVENTOM = EH.NREVENTOM)
    					)';
        $resultado = $db->fetchAll($sql);
        $eventos_media = self::createObjectsFromArray($resultado);

        foreach ($eventos_media as &$evento_med) {
            $dao = $evento_med->getDao();
            /* $historico = $dao->retornaUltimoHistorico($dao->NREVENTOM); */
            $historico = Fpaeventoh::retornaUltimoHistorico($dao->NREVENTOM);
            $evento_med->historico = $historico;
        }

        return $eventos_media;

    }


    /**
     * Retorna lisyta de eventos que fazem base para calculo de faltas.
     *
     * @param integer $nrOrg Numero da Organizacao.
     *
     * @return array FpaeventomEntity
     *
     * @author alessandrobartels -
     *         alessandrobartels - 27/06/2011 - Implementacao do NRORG
     */

    public static function retornaListaEventosFalta($nrOrg, $nrOrgPadrao){
        $eventos_media = array();

        /* $db = TkDb::singleton(); */
        $db = \Setforms2\Runtime\Connection::getInstance();
        $sql = 'SELECT * FROM FPA_EVENTOM EM
				WHERE
				(EM.NRORG = '.$nrOrg.'
				 OR EM.NRORG = '.$nrOrgPadrao.')
				AND EM.NREVENTOM IN
  						(SELECT EH.NREVENTOM  FROM FPA_EVENTOH EH
    					WHERE EH.IDFALTASFERIAS <> \'NENHUM\'
    					AND EH.DTMESCOMPETENC = (SELECT MAX(EH1.DTMESCOMPETENC)
    											FROM FPA_EVENTOH EH1
                              					WHERE EH1.NREVENTOM = EH.NREVENTOM)
    					)';
        $resultado = $db->fetchAll($sql);
        $eventos_falta = self::createObjectsFromArray($resultado);

        foreach ($eventos_falta as &$evento_ft) {
            $dao = $evento_ft->getDao();
            /* $historico = $dao->retornaUltimoHistorico($dao->NREVENTOM); */
            $historico = Fpaeventoh::retornaUltimoHistorico($dao->NREVENTOM);
            $evento_ft->historico = $historico;
        }

        return $eventos_falta;

    }


    /**
     * Retorna o Objeto EventoM.
     *
     * @param integer $nreventom Nr Evento.
     * @param integer $nrorg     Nr org.
     *
     * @return FpaeventomEntity
     *
     * @author luistavares - 11/08/2011
     */
    public static function retornaEvento($nreventom, $nrorg){
        $eventom = self::getObjectByWhere(
            'NRORG = ?
             AND NREVENTOM = ?',
            array(
             $nrorg, $nreventom,
            )
        );
        return $eventom;
    }


}